
opendir(my $dh1, ".") || die;
while (readdir $dh1) {
    next if (/^\./);
    next if (-f $_);

    $path1 = $_;
    
    opendir(my $dh2, $path1) || die;
    while (readdir $dh2) {
        next if (/^\./);
        
        $path2 = $_;

        if (/\.xlogic(|-t)$/) {
            # print "$path1/$path2\n";

            open(my $fh1, "<:encoding(UTF-8)", "$path1/$path2") || die;
            open(my $fh2, ">:encoding(UTF-8)", "$path1/$path2" . ".new") || die;
            
            while (<$fh1>) {
                if (/<flyingLogic majorVersion="3" minorVersion="0">/) {
                    print $fh2 "<flyingLogic majorVersion=\"4\" minorVersion=\"0\">\n";
                } else {
                    print $fh2 $_;
                }
            }
            
            close $fh1;
            close $fh2;
            
            unlink "$path1/$path2";
            rename "$path1/$path2" . ".new", "$path1/$path2";
        }

        if (/\.xlogic-d$/) {
            # print "$path1/$path2\n";
            
            open(my $fh1, "<:encoding(UTF-8)", "$path1/$path2") || die;
            open(my $fh2, ">:encoding(UTF-8)", "$path1/$path2" . ".new") || die;
            
            while (<$fh1>) {
                if (/<domain majorVersion="3" minorVersion="0">/) {
                    print $fh2 "<domain majorVersion=\"4\" minorVersion=\"0\">\n";
                } else {
                    print $fh2 $_;
                }
            }
            
            close $fh1;
            close $fh2;
            
            unlink "$path1/$path2";
            rename "$path1/$path2" . ".new", "$path1/$path2";
        }
    }
    closedir $dh2;
}
closedir $dh1;